<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<title>Index Builder</title>
</head>

<body>

<?
	require("_pgdb.php");
	
	echo "Rebuilding index<hr>";
	flush();
	build_index($id);
	echo "<br><hr>Index rebuilt";
	
	pg_close($db);
?>

</body>
</html>

<?
/***
	Builds index $index for URL $url with the URL restriction $restriction.
***/
	function build_index($id)
	{
		global $db;
	
		$index = pg_exec($db, "SELECT * FROM index WHERE id = $id");
		$index = pg_fetch_array($index, 0);
		$list[] = $index["url"];
		pg_exec($db, "DELETE FROM hit WHERE index = $id");
		pg_exec($db, "DELETE FROM page WHERE index = $id");
		pg_exec($db, "DELETE FROM word WHERE index = $id");
		list_url($list, $index["restrict"], $id);
	}

/***
	Gets a list of words from $url using get_url() and adds it to index $index.
***/
	function index_url($url, $index)
	{
		global $db;

		set_time_limit(300);
		echo "$url<br>"; 
		flush();
		scan_url($url, $words);
		if (!count($words))
			return;
		$page = pg_exec($db, "SELECT id FROM page WHERE index = $index AND url = '$url'");
		if (!pg_numrows($page))
		{
			$nextid = pg_exec($db, "SELECT MAX(id) as nextid FROM page");
			$pageid = pg_result($nextid, 0, "nextid") + 1;
			pg_exec($db, "INSERT INTO page(id, index, url) VALUES($pageid, $index, '$url')");
		}
		else
			$pageid = pg_result($page, 0, "id");
		foreach($words as $key => $val)
		{
			$key = str_replace("'", "''", $key);
			$word = pg_exec($db, "SELECT id FROM word WHERE name = '$key' AND index = $index");
			if (!pg_numrows($word))
			{
				$nextid = pg_exec($db, "SELECT MAX(id) as nextid FROM word");
				$wordid = pg_result($nextid, 0, "nextid") + 1;
				pg_exec($db, "INSERT INTO word(id, index, name) VALUES($wordid, $index, '$key')");
			}
			else
				$wordid = pg_result($word, 0, "id");
			pg_exec($db, "INSERT INTO hit(index, page, word, hits) VALUES($index, $pageid, $wordid, $val)");
		}
	}

/***
	Calls index_url() for all the URL's found below the one passed as a list in $list.
***/
	function list_url($list, $restrict, $index)
	{
		static $done = "";

		if (!count($list))
			return;
		foreach($list as $val)
		{
			if (!stristr($val, $restrict))
				continue;
			if (isset($done[$val]))
				continue;
			$done[$val] = true;
			index_url($val, $index);
			list_url(build_url($val), $restrict, $index);
		}
	}

/***
	Returns a list of indexable URL's from the HTML found at URL $url.
	Each URL is checked for an HTTP/1.0 200 response.
***/
	function build_url($url)
	{
		$base = substr($url, 0, strrpos($url, "/"));
		$abase = substr(strstr(substr(substr($url, strpos($url, "//") + 2), 1), "/"), 1);
		$abase = substr($abase, 0, strrpos($abase, "/"));
		if (strlen($abase))
			$base = substr($base, 0, strpos($base, $abase));
		if (!$fp = @fopen($url, "r"))
			return;
		while (!feof($fp))
			$buf .= fgets($fp, 65535);
		fclose($fp);
		$buf = ereg_replace("[\n\r]", " ", $buf);
		$links = get_url($buf);
		if (isset($links))
			foreach($links as $link)
			{
				if (($link[strlen($link) - 1] != "/") &&
					(!eregi(".htm|.html|.cfm|.cfml|.inc|.shtm|.shtml|.txt|.php", $link)))
					continue;	
				$info = parse_url($link);
				if (isset($info["scheme"]))
				{
					if (($info["scheme"] != "http") && ($info["scheme"] != "ftp"))
						continue;
				}
				else
				{
					if (!strlen($info["path"]))
						continue;
					if ($link[0] == "/")
						$link = $base . $abase . $link;
					else if (substr($link, 0, 3) != "../")
						$link = $base . $abase . "/" . $link;
					else
					{
						$lbase = $abase;
						while (substr($link, 0, 3) == "../")
						{
							$link = substr($link, 3);
							$lbase = substr($lbase, 0, strrpos($lbase, "/"));
						}
						if (strlen($lbase))
							$lbase .= "/";
						$link = $base . $lbase . $link;
					}
				}
				$urli = parse_url($link);
				if ($fp = fsockopen($urli["host"], 80, $str, $str, 30))
				{
				 	fputs($fp, "GET " . $link . " HTTP/1.0\n\n");
					$str = fgets($fp, 64);
				 	fclose($fp);
				}
				else
					continue;
				if (substr($str, strpos($str, " ") + 1, 3) != "200")
					continue;
				$list[] = $link;
			}

		return $list;
	}

/***
	Returns a list of possibly valid URL's from the prepared text in $buf.
***/
	function get_url($buf)
	{
		preg_match_all("/<(?i)(area |a |frame )[^>]+>/", $buf, $tag);
		if (isset($tag))
			foreach($tag[0] as $val)
			{
				preg_match_all('/(?i)(href ?|src ?)="?([^"> ]*)/', $val, $str);
				if (isset($str))
					foreach($str[2] as $val)
						$link[] = substr($val, 0, strcspn($val, "#"));
			}

		return $link;
	}

/***
	Adds to $words all the frequencies of words at URL $url. 
***/
	function scan_url($url, &$words)
	{
		if (!$fp = @fopen($url, "r"))
			return;
		while (!feof($fp))
			$buf .= fgets($fp, 65535);
		fclose($fp);
		$buf = strtolower(strip_tags(ereg_replace("[\n\r]", " ", $buf)));
		$buf = ereg_replace("[^[:alnum:].@-]", " ", $buf);
		$buf = ereg_replace("([[:alnum:]]*)([.@-][^[:alnum:]])", "\\1 ", $buf);
		$buf = ereg_replace("([^[:alnum:]][@-])([[:alnum:]]*)", " \\2", $buf);
		$buf = ereg_replace("([^[:alnum:]][.])([^[:digit:]])", " \\2", $buf);
		$buf = trim(ereg_replace("  *", " ", $buf));
		$buf = explode(" ", $buf);
		foreach($buf as $val)
			if (isset($words[$val]))
				$words[$val]++;
			else
				$words[$val] = 1;
	}
?>
